#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/epoll.h>
#include <unistd.h>

int main(void)
{
	int lfd = socket(PF_INET, SOCK_STREAM, 0);

	struct sockaddr_in addr_listen;
	addr_listen.sin_family = AF_INET;
	addr_listen.sin_addr.s_addr = INADDR_ANY;
	addr_listen.sin_port = htons(7777);

	bind(lfd, (struct sockaddr*)&addr_listen, sizeof(addr_listen));
	listen(lfd, 2048);

	int fd1 = accept(lfd, NULL, NULL);
	int fd2 = accept(lfd, NULL, NULL);



	int epfd = epoll_create(1024);

	struct epoll_event ev;

	ev.events = EPOLLIN;
	ev.data.fd = fd1;
	epoll_ctl(epfd, EPOLL_CTL_ADD, fd1, &ev);

	ev.events = EPOLLIN;
	ev.data.fd = fd2;
	epoll_ctl(epfd, EPOLL_CTL_ADD, fd2, &ev);

	struct epoll_event evbuffer[128];
	int nevent = epoll_wait(epfd, evbuffer, 128, -1);

	int i;
	for(i=0; i < nevent; ++i) {
		int fd = evbuffer[i].data.fd;
		/* ... */
	}

	close(epfd);

	return 0;
}

