#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <errno.h>
#include <sys/event.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/uio.h>
#include <errno.h>
#include <stdlib.h>

int main(void)
{
	int lfd = socket(PF_INET, SOCK_STREAM, 0);

	struct sockaddr_in addr_listen;
	addr_listen.sin_family = AF_INET;
	addr_listen.sin_addr.s_addr = INADDR_ANY;
	addr_listen.sin_port = htons(7777);

	bind(lfd, (struct sockaddr*)&addr_listen, sizeof(addr_listen));
	listen(lfd, 2048);

	int fd1 = accept(lfd, NULL, NULL);
	int fd2 = accept(lfd, NULL, NULL);


	int kqfd = kqueue();

	struct kevent kev[128];
	EV_SET(&kev[0], fd1, EVFILT_READ, EV_ADD, 0, 0, NULL);
	EV_SET(&kev[1], fd2, EVFILT_READ, EV_ADD, 0, 0, NULL);

	int nevent = kevent(kqfd, kev, 2, kev, 128, NULL);

	for(int i=0; i < nevent; ++i) {
		int fd = kev[i].ident;
		/* ... */
	}

	close(kqfd);

	return 0;
}

